Draft BSpline: Difference between revisions

From FreeCAD Documentation
({{Button}} instead of {{KEY}} template; information removed because it's described in the options.)
(More information for the options)
Line 21: Line 21:


==Options== <!--T:5-->
==Options== <!--T:5-->
* Press {{KEY|F}} or the {{KEY|[[Image:Draft FinishLine.png|12px]] '''[[Draft_FinishLine|Finish]]'''}} button to finish the spline, leaving it open
* Press {{KEY|A}} or the {{Button|[[Image:Draft FinishLine.png|12px]] [[Draft_FinishLine|Finish]]}} button to finish the spline, leaving it open.
* Press {{KEY|C}} or the {{KEY|[[Image:Draft CloseLine.png|12px]] '''[[Draft_CloseLine|Close]]'''}} button or click on the first point to finish the spline, but making it closed by adding a last segment between the last point and the first one.
* Press {{KEY|O}} or the {{Button|[[Image:Draft CloseLine.png|12px]] [[Draft_CloseLine|Close]]}} button to close the spline, that is, a curve will be added from the last point to the first one to form a face. At least three points are required to form a face.
* Press {{KEY|W}} or the {{Button|[[Image:Draft Wipe.svg|12px]] [[Draft_Wipe|Wipe]]}} button to remove the curve segments already placed, but keep editing the spline from the last point.
* Press {{KEY|U}} or the {{Button|[[Image:Draft SelectPlane.svg|12px]] [[Draft_SelectPlane|Set WP]]}} button to adjust the current working plane in the orientation of the last point.
* Press {{KEY|X}}, {{KEY|Y}} or {{KEY|Z}} after a point to constrain the next point on the given axis.
* Press {{KEY|X}}, {{KEY|Y}} or {{KEY|Z}} after a point to constrain the next point on the given axis.
* To enter coordinates manually, simply enter the numbers, then press {{KEY|ENTER}} between each X, Y and Z component.
* To enter coordinates manually, simply enter the numbers, then press {{KEY|Enter}} between each X, Y and Z component.
* Press {{KEY|R}} or click the checkbox to check/uncheck the {{KEY|'''Relative'''}} button. If relative mode is on, the coordinates of the next point are relative to the last one. If not, they are absolute, taken from the (0,0,0) origin point.
* Press {{KEY|R}} or click the checkbox to toggle ''relative'' mode. If relative mode is on, the coordinates of the next point are relative to the last one; if not, they are absolute, taken from the origin (0,0,0).
* Press {{KEY|T}} or click the checkbox to check/uncheck the {{KEY|'''Continue'''}} button. If continue mode is on, the BSpline tool will restart after you finish or close it, allowing you to draw another one without pressing the BSpline button again.
* Press {{KEY|T}} or click the checkbox to toggle ''continue'' mode. If continue mode is on, the BSpline tool will restart after you finish the spline, allowing you to draw another one without pressing the tool button again.
* Press {{KEY|L}} or click the checkbox to toggle ''filled'' mode. If filled mode is on, a closed spline will create a filled face ({{PropertyData|Make Face}} {{TRUE}}); if not, the closed spline will not make a face ({{PropertyData|Make Face}} {{FALSE}}).
* Press {{KEY|CTRL}} while drawing to force [[Draft_Snap|snapping]] your point to the nearest snap location, independently of the distance.
* Press {{KEY|SHIFT}} while drawing to [[Draft_Constrain|constrain]] your next point horizontally or vertically in relation to the last one.
* Press {{KEY|Ctrl}} while drawing to force [[Draft_Snap|snapping]] your point to the nearest snap location, independently of the distance.
* Press {{KEY|W}} or press the {{KEY|[[Image:Draft Wipe.png|12px]] '''Wipe'''}} button to remove the existing segments and start the spline from the last point.
* Press {{KEY|Shift}} while drawing to [[Draft_Constrain|constrain]] your next point horizontally or vertically in relation to the last one.
* Press {{KEY|CTRL}}+{{KEY|Z}} or press the {{KEY|[[Image:Draft UndoLine.png|12px]] '''[[Draft_UndoLine|Undo]]'''}} button to undo the last point.
* Press {{KEY|Ctrl}}+{{KEY|Z}} or press the {{Button|[[Image:Draft UndoLine.png|12px]] [[Draft_UndoLine|Undo]]}} button to undo the last point.
* Press {{KEY|I}} or the {{KEY|'''Filled'''}} button to have the spline filled with a face after it has been closed.
* Press {{KEY|Esc}} or the {{button|Cancel}} button to abort the current command; curve segments already placed will remain.
* Press {{KEY|ESC}} or the {{KEY|'''Cancel'''}} button to abort the current BSpline command.
* BSplines, when in "Flat Lines" display mode, can display a hatch pattern, by setting their "Pattern" property below.


==Properties== <!--T:6-->
==Properties== <!--T:6-->

Revision as of 02:54, 8 November 2018

Draft BSpline

Menu location
Draft → BSpline
Workbenches
Draft, Arch
Default shortcut
B S
Introduced in version
-
See also
Draft Wire, Draft Line

Description

The BSpline tool creates a B-Spline curve from several points in the current work plane. It uses the Draft Linestyle set on the Draft Tray. The BSpline tool behaves like the Draft Wire tool, but is curved.

How to use

  1. Press the Draft BSpline button, or press B then S keys
  2. Click a first point on the 3D view, or type a coordinate
  3. Click additional point on the 3D view, or type a coordinate

Options

  • Press A or the Finish button to finish the spline, leaving it open.
  • Press O or the Close button to close the spline, that is, a curve will be added from the last point to the first one to form a face. At least three points are required to form a face.
  • Press W or the Wipe button to remove the curve segments already placed, but keep editing the spline from the last point.
  • Press U or the Set WP button to adjust the current working plane in the orientation of the last point.
  • Press X, Y or Z after a point to constrain the next point on the given axis.
  • To enter coordinates manually, simply enter the numbers, then press Enter between each X, Y and Z component.
  • Press R or click the checkbox to toggle relative mode. If relative mode is on, the coordinates of the next point are relative to the last one; if not, they are absolute, taken from the origin (0,0,0).
  • Press T or click the checkbox to toggle continue mode. If continue mode is on, the BSpline tool will restart after you finish the spline, allowing you to draw another one without pressing the tool button again.
  • Press L or click the checkbox to toggle filled mode. If filled mode is on, a closed spline will create a filled face (DataMake Face true); if not, the closed spline will not make a face (DataMake Face false).
  • Press Ctrl while drawing to force snapping your point to the nearest snap location, independently of the distance.
  • Press Shift while drawing to constrain your next point horizontally or vertically in relation to the last one.
  • Press Ctrl+Z or press the Undo button to undo the last point.
  • Press Esc or the Cancel button to abort the current command; curve segments already placed will remain.

Properties

  • DataClosed: Specifies if the spline is closed or not
  • DataMake Face: Fills the spline with a face
  • ViewEnd Arrow: Shows an arrow symbol at the last point of the spline, so it can be used as an annotation leader line
  • ViewPattern: Specifies a hatch pattern to fill the wire with
  • ViewPattern Size: Specifies the size of the hatch pattern

Scripting

The BSpline tool can by used in macros and from the python console by using the following function:

makeBSpline (pointslist,[closed],[placement])
  • Creates a B-Spline object from the given list of vectors.
  • If closed is True or first and last points are identical, the wire is closed.
  • If face is true (and the bspline is closed), the bspline will appear filled.
  • Instead of a list of points, you can also pass a Part Wire.
  • Returns the newly created object.

Example:

import FreeCAD,Draft
p1 = FreeCAD.Vector(0,0,0)
p2 = FreeCAD.Vector(1,1,0)
p3 = FreeCAD.Vector(2,0,0)
Draft.makeBSpline([p1,p2,p3],closed=True)